package comp3804a4;

import java.util.ArrayList;
import java.util.List;

public class Graph {
    private final List<Vertex> vertices = new ArrayList<>();
    
    public void addVertex(Vertex v) {
        vertices.add(v);
    }
    
    public List<Vertex> getVertices() {
        return vertices;
    }
    
    public void addEdge(Vertex u, Vertex v, double weight) {
        u.getNeighbours().put(v, weight);
        v.getNeighbours().put(u, weight);
    }
}
