package comp3804a4;

public class MSTComputer {

    public double getMSTLength(Graph g) {
        return 0; // TODO
    }

    public static void main(String[] args) {
        // Example from Lecture 16
        Graph g = new Graph();
        Vertex a = new Vertex(),
                b = new Vertex(),
                c = new Vertex(),
                d = new Vertex(),
                e = new Vertex(),
                f = new Vertex();

        g.addVertex(a);
        g.addVertex(b);
        g.addVertex(c);
        g.addVertex(d);
        g.addVertex(e);
        g.addVertex(f);

        g.addEdge(a, b, 5);
        g.addEdge(a, c, 6);
        g.addEdge(a, d, 4);
        g.addEdge(b, c, 1);
        g.addEdge(b, d, 2);
        g.addEdge(c, d, 2);
        g.addEdge(c, e, 5);
        g.addEdge(c, f, 3);
        g.addEdge(d, f, 4);
        g.addEdge(e, f, 4);

        System.out.print("Checking basic correctness... ");
        MSTComputer mst = new MSTComputer();
        double length = mst.getMSTLength(g);
        if (Math.abs(length - 14) > 0.00000001) {
            System.out.println("MST length should be 14, but is " + length);
        } else {
            System.out.println("Looks okay so far. This doesn't mean it's correct: the server does a LOT more tests.");
        }

        int n = 1000;
        double[] costs = new double[]{17, 11, 4, 9, 19, 20, 13, 14, 16, 2, 8, 3, 5, 1, 15, 10, 6, 18, 7, 12};
        g = new Graph();
        for (int i = 0; i < n; i++) {
            g.addVertex(new Vertex());
        }
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                g.addEdge(g.getVertices().get(i), g.getVertices().get(j), costs[(i + j) % (1 + (i % costs.length))]);
            }
        }
        
        System.out.println("Testing basic efficiency: this should take less than a second...");
        long start = System.currentTimeMillis();
        
        System.out.println(mst.getMSTLength(g));

        System.out.println("Done. That took " + ((System.currentTimeMillis() - start) / 1000.0) + " seconds.");
    }
}
